package com.agiledeveloper;

class A
{
}

class B
{
}

public class Example
{
    public static void foo1(A obj)
    {
        System.out.println("foo called with " + obj);
    }

    public static void foo2(A obj1, B obj2)
    {
        System.out.println("foo2 called with " + obj1 + " and " + obj2);
    }

    public static void foo3(int value)
    {
        System.out.println("foo3 called witih " + value);
    }

    // Poor mimic of refelction API to illustrate the point
    public static void invoke(String method, Object[] args)
    {
        if (method.equals("foo1"))
        {
            foo1((A)args[0]);
        }
        if (method.equals("foo2"))
        {
            foo2((A) args[0], (B) args[1]);
        }
        if (method.equals("foo3"))
        {
            foo3(((Integer)(args[0])).intValue());
        }
    }

    public static Integer foo4(Integer v)
    {
        System.out.println("foo4 called with " + v.intValue());
        return new Integer(5);
    }

    public static void main(String[] args)
    {
        invoke("foo1", new Object[] {new A()});
        invoke("foo2", new Object[]{new A(), new B()});

        invoke("foo3", new Object[] { new Integer(3) }); // Until Java 1.4

        //Now
        invoke("foo3", new Object[]{ 3 }); // In Java 5

        int someValue = foo4(4);
        System.out.println("Result of call to foo4 " + someValue);
    }
}
